import std.stdio;

void main()
{
    int a = -1;                 // То есть 0xFFFF_FFFF
    int b = a << 1;
    assert(b == -2);            // 0xFFFF_FFFE
    writeln("a = ", a, "; b = ", b, ';');
    int c = a >> 1;
    assert(c == -1);            // 0xFFFF_FFFF
    writeln("a = ", a, "; c = ", c, ';');
    int d = a >>> 1;
    assert(d == +2147483647);   // 0x7FFF_FFFF
    writeln("a = ", a, "; d = ", d, ';');
}
